<?php
// ----------------------------------------------------------------------
// Fast Click - Clicks Counter System
// Copyright (c) 2001-2003 by Dmitry Ignatyev (ftrain@mail.ru)
// http://www.ftrain.hotbox.ru/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Dmitry Ignatyev
// ----------------------------------------------------------------------

include("cfg.php");

if(file_exists("language/".$language.".php"))
  include("language/".$language.".php");
else
  @include("language/english.php");

$version = "v2.3.4";

if(isset($ad)) $fid = $ad;

// HTML Header

function head() {
?>
<html>
<head>
 <title>Fast Click</title>
 <meta http-equiv="Content-type" content="text/html; charset=<?=_CHARSET?>">
 <link href="style.css" type="text/css" rel="stylesheet">
</head>
<body bgcolor="#FFFFFF">
<?php
}

// HTML Foot

function foot() {
global $version;
echo "<br><div align=center><a href=\"http://www.ftrain.hotbox.ru\">FastClick</a> ".$version."</div>\n";
echo "<div align=center>Copyright &copy;2003 by Trainer</div>\n";
echo "</body></html>";
}

// Administrator Login

function login() {
 global $HTTP_POST_VARS, $sPassword;//, $HTTP_SESSION_VARS;

 if(isset($HTTP_POST_VARS["pass"])) $pass = $HTTP_POST_VARS["pass"];

 if(isset($pass) && ($pass == $sPassword)) {
//   $HTTP_SESSION_VARS["log"] = 1;
   $_SESSION['log'] = 1;
   $log = 1;
   session_register('log');
   Header("Location: admin.php");
  }
 else if(isset($pass)) {
   $warning = "<br><font color=#ff0000>"._WRONGPASS."</font>";
  }

 if(!isset($warning)) $warning = "";

 head();
?>
 <TABLE bgcolor="#000000" cellpadding=0 cellspacing=1 border=0 width="250" align=center>
  <TR>
   <TD>
     <TABLE bgcolor="#FFFFFF" cellpadding=2 cellspacing=1 border=0 width="100%" class=text>
       <form action="admin.php" method=post>
       <TR><TD bgcolor="#a5bcc0" align=center style="font-size:11pt;"><?=_ADMINLOGIN?></TD></TR>
       <TR>
         <TD bgcolor="#e9e9e9" align=center>
          <?=$warning?>
          <p class=form><?=_PASSWORD?>:<br><input type=password name=pass class=field></p>
          <input type="submit" value="Login" class=button><br><br>
         </TD>
       </TR>
       </form>
     </TABLE>
   </TD>
  </TR>
 </TABLE>
<?php
 foot();
}

// Click Statistic

function show() {
 global $datafile, $dayfile, $groupfile, $gr;
 head();

 $today=(int)(time()/86400);
 $gr += 0;

 $num = 0; $all=0; $today_all=0; $last_all=0; $last7_all=0;

 $base=@file($datafile); $cnt=sizeof($base);
 $last_date=date("d F Y H:i",$base[0]);
 for($i=1;$i<$cnt;$i++) {
   list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
   if($gr==$group) { //||!$gr) {
     $id_b[$num] = $id;
     $total_b[$id] = $count;
     $url_b[$id] = $url;
     $name_b[$id] = $name;
     $all+=$count;
     $num++;
    }
  }

 $day_base=@file($dayfile); $cnt=sizeof($day_base);
 for($i=0;$i<$cnt;$i++) {
   list($day,$group,$id,$count)=explode("|", $day_base[$i]);
   if($gr==$group) { //||!$gr) {
     if($day==$today) { $today_b[$id]+=$count; $today_all+=$count; }
     else if($day==$today-1) { $last_b[$id]+=$count; $last_all+=$count; }
     $last7_b[$id]+=$count; $last7_all+=$count;
    }
  }
?>
<DIV align=center style="font-size:14pt; letter-spacing:2pt;"><B><?=_STATISTIC?></B></DIV>
<TABLE cellpadding=4 cellspacing=4 border=0 width="100%">
 <TR>
  <TD valign=top>
   <TABLE border=0 class=text width="100%" cellpadding=2 cellspacing=1>
    <TR><TD bgcolor="#a5bcc0" align=center style="font-size:9pt;"><B>.: <?=_MENU?> :.</B></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>"><B>.: <?=_STATISTIC?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=config"><B>.: <?=_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=gr_config"><B>.: <?=_GR_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?admin=logout"><B>.: <?=_LOGOUT?></B></A></TD></TR>
   </TABLE>
  </TD>
  <TD width="85%">
   <FORM ACTION="admin.php" METHOD=post>
    <div class=text style="margin-bottom:2pt;"><?=_GROUP?>:
    <select name="gr" onChange="top.location.href='admin.php?gr='+this.options[this.selectedIndex].value;">
     <option value=0><?=_COMMON?></option>
<?php
 $group_base=@file($groupfile); $cnt=sizeof($group_base);
 for($i=0;$i<$cnt;$i++) {
   list($id,$grname)=explode("|", $group_base[$i]);
   echo "     <option ";
   if($gr == $id) echo "selected ";
   echo "value=\"".$id."\">".$grname."</option>\n";
  }
?>
    </select></div>
   <TABLE bgcolor="#000000" cellpadding=0 cellspacing=1 border=0 width="100%">
    <TR>
     <TD>
       <TABLE bgcolor="#FFFFFF" cellpadding=2 cellspacing=1 border=0 width="100%" class=text>
        <TR><TD bgcolor="#a5bcc0" align=center colspan=6><?=_CLICKSTAT?></TD></TR>
        <TR>
         <TD bgcolor="#c5dce0" align=center><B><?=_LINK?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_TODAY?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_YESTERDAY?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_FORWEEK?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_TOTAL?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_REFERRINGPAGES?></B></TD>
        </TR>
<?php
 for($i=0;$i<$num;$i++) {
   $id=$id_b[$i];
   if(!isset($today_b[$id])) $today_b[$id] = 0;
   if(!isset($last_b[$id])) $last_b[$id] = 0;
   if(!isset($last7_b[$id])) $last7_b[$id] = 0;
   $raz = $today_b[$id] - $last_b[$id];
   echo "        <TR>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center><a href=\"".$url_b[$id]."\">".$name_b[$id]."</a></TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".$today_b[$id];
   if($raz > 0) echo " <font color=\"#00aa00\">+".$raz."</font>";
   else if($raz < 0) echo " <font color=\"#ff0000\">".$raz."</font>";
   echo "</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".$last_b[$id]."</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".$last7_b[$id]."</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".$total_b[$id]."</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:window.open('admin.php?admin=show_ref&fid=".$id."','referrer','scrollbars,resizable,width=620,height=420');void(0);\">"._SHOW."</a></TD>\n";
   echo "        </TR>\n";
  }
 echo "        <TR>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>"._TOTAL."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$today_all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$last_all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$last7_all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center></TD>\n";
 echo "        </TR>\n";
 echo "        <TR><TD colspan=6 align=center><b>"._TOTALLINKS.": <font color=\"#556c70\">".$num."</font>\n";
 echo "         | "._LASTCLICK.": <font color=\"#556c70\">".$last_date."</font></b></TD></TR>\n";
?>
       </TABLE>
     </TD>
    </TR>
   </TABLE>
   </FORM>
  </TD>
 </TR>
</TABLE>
<?php
 foot();
}

// Configure

function config() {
 global $datafile, $error_m, $gr, $groupfile;
 $gr+=0;
 head();
?>
<script language="Javascript">
<!--
function check_char(strg) {
 var found = 0;
 for(char_pos=0; char_pos<strg.length; char_pos++) {
   if(strg.charAt(char_pos) == "|" || strg.charAt(char_pos) == "=" || strg.charAt(char_pos) == '"' || strg.charAt(char_pos) == "'") {
     found = 1;
     break;
    }
  }
 return (found == 1) ? false : true;
}
function set_value(entry, old_value) {
 var new_value = window.prompt("<?=_CHCOUNTER?> '"+entry+"' <?=_TO?>:",old_value)
 var found = 0;
 if(new_value != "" && new_value != null) {
   for(char_pos=0; char_pos<new_value.length; char_pos++) {
     if(!(new_value.charAt(char_pos) >= '0' && new_value.charAt(char_pos) <= '9')) {
       found = 1;
      }
    }
   if (found == 1) {
     alert ("<?=_WRONGVALUE?> "+entry+"!");
    }
   else if (new_value == old_value) {
     alert ("<?=_CHNOTMADE?>!");
    }
   else {
     window.location.href = "admin.php?admin=ch_count&fid="+entry+"&new="+new_value
    }
  }
}
function ChangeEntry(entry, old_name, feature) {
 var new_name = window.prompt("<?=_ENTER?> "+feature+" <?=_FOR?> "+entry+":",old_name)
 var found = 1;
 if(new_name != "" && new_name != null) {
   if(check_char(new_name)) {
     found = 0;
    }
   if (found == 1) {
     alert ("<?=_ERROR?>! "+feature+" <?=_FOR?> "+entry+" <?=_UNACCEPTCHARS?>!");
    }
   else if(new_name == old_name) {
     alert ("<?=_CHNOTMADE?>!");
    }
   else if(feature == "Name") {
     window.location.href = "admin.php?admin=ch_name&fid="+entry+"&new="+new_name
    }
   else if(feature == "ID") {
     window.location.href = "admin.php?admin=ch_id&fid="+entry+"&new="+new_name
    }
   else if(feature == "URL") {
     window.location.href = "admin.php?admin=ch_url&fid="+entry+"&new="+new_name
    }
  }
}
function del_entry(entry) {
 if (window.confirm("<?=_CONFIRMDEL?>: "+entry)) {
    window.location.href = "admin.php?admin=del&fid="+entry
 }
}
function clear_entry(entry) {
 if (window.confirm("<?=_CONFIRMDELSTAT?>: "+entry)) {
    window.location.href = "admin.php?admin=clear&fid="+entry
 }
}
function check_form() {
 var found = 1;
 name_field=document.form.add_name.value;
 id_field=document.form.add_id.value;
 if (name_field == "" || id_field == "") {
    alert ("<?=_PLEASEFILL?>");
    return false;
 }
 if (check_char(name_field) && check_char(id_field)) {
    found = 0;
 }
 if (found == 1) {
    alert ("<?=_ERROR?>! <?=_FOUNDUNACCEPTCHARS?>!");
    return false;
 }
}
function ch_group(entry) {
 chWin = open("", "ChangeWin",
         "width=250,height=140,status=0,toolbar=0,menubar=0");
 doc = chWin.document;
 doc.open();
 doc.write("<html>\n<head>\n <title><?=_CHGROUP?></title>\n");
 doc.write(' <meta http-equiv="Content-type" content="text/html; charset=<?=_CHARSET?>">\n');
 doc.write(' <link href="style.css" type="text/css" rel="stylesheet">\n');
 doc.write('</head>\n');

 doc.write("<body bgcolor=\"#e9e9e9\">\n<table border=0 class=text width=\"100%\" align=center>\n");
 doc.write("<form name=form>\n<tr><td align=center><?=_CHNEWGROUP?> "+entry+"</td></tr>\n");
 doc.write('<tr><td align=center>\n<select name=new2 style="width: 150pt;">\n');
 doc.write('<option value=0><?=_COMMON?></option>\n');
<?php
 $group_base=@file($groupfile); $cnt=sizeof($group_base);
 for($i=0;$i<$cnt;$i++) {
   list($id,$grname)=explode("|", $group_base[$i]);
   echo " doc.write('<option ";
   if($gr == $id) echo "selected ";
   echo "value=\"".$id."\">".$grname."</option>\\n');\n";
  }
?>
 doc.write('</select>\n</td></tr>\n');
 doc.write('<tr><td align=center>\n<input type="submit" value="<?=_REMOVE?>" class=button style="width: 150pt;"\n');
 doc.write(' onclick="self.opener.location.href=\'admin.php?gr=<?=$gr?>&admin=ch_group&fid='+entry+'&new=\'+ document.form.new2.options[document.form.new2.selectedIndex].value;self.close();"');
 doc.write(">\n</td></tr>\n");
 doc.write("</form>\n");
 doc.write("</table>\n</body></html>");
 doc.close();
}

// -->
</script>
<DIV align=center style="font-size:14pt; letter-spacing:2pt;"><B><?=_CONTROLPANEL?></B></DIV>
<TABLE cellpadding=4 cellspacing=4 border=0 width="100%">
 <TR>
  <TD valign=top>
   <TABLE border=0 class=text width="100%" cellpadding=2 cellspacing=1>
    <TR><TD bgcolor="#a5bcc0" align=center style="font-size:9pt;"><B>.: <?=_MENU?> :.</B></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>"><B>.: <?=_STATISTIC?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=config"><B>.: <?=_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=gr_config"><B>.: <?=_GR_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?admin=logout"><B>.: <?=_LOGOUT?></B></A></TD></TR>
   </TABLE>
  </TD>
  <TD width="85%">
   <FORM ACTION="admin.php" METHOD=post>
    <div class=text style="margin-bottom:2pt;"><?=_GROUP?>:
    <select name=gr onChange="top.location.href='admin.php?admin=config&gr='+this.options[this.selectedIndex].value;">
     <option value=0><?=_COMMON?></option>
<?php
 $group_base=@file($groupfile); $cnt=sizeof($group_base);
 for($i=0;$i<$cnt;$i++) {
   list($id,$grname)=explode("|", $group_base[$i]);
   echo "     <option ";
   if($gr == $id) echo "selected ";
   echo "value=\"".$id."\">".$grname."</option>\n";
  }
?>
    </select></div>
   <TABLE bgcolor="#000000" cellpadding=0 cellspacing=1 border=0 width="100%">
    <TR>
     <TD>
      <TABLE bgcolor="#FFFFFF" cellpadding=2 cellspacing=1 border=0 width="100%" class=text>
       <TR><TD bgcolor="#a5bcc0" align=center colspan=5><?=_LINKSLIST?></TD></TR>
       <TR>
        <TD bgcolor="#c5dce0" align=center><B><?=_ID?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_NAME?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_URL?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_CLICKS?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_ACTIONS?></B></TD>
       </TR>
<?php
 $base=@file($datafile); $cnt=sizeof($base)-1;
 $num=0;
 for($i=1;$i<=$cnt;$i++) {
   list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
   if($gr==$group) { //||!$gr) {
     echo "       <TR>\n";
     echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('".$id."', '".$id."', 'ID')\" class=opt>".$id."</a></TD>\n";
     echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('".$id."', '".$name."', 'Name')\" class=opt>".$name."</a></TD>\n";
     echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('".$id."', '".$url."', 'URL')\"\n";
     echo "         class=opt>".$url."</a></TD>\n";
     echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:set_value('".$id."', '".$count."')\" class=opt>".$count."</a></TD>\n";
     echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:del_entry('".$id."');\" class=opt>"._DELETE."</a>\n";
     echo "          : <a href=\"javascript:clear_entry('".$id."');\" class=opt>"._CLEAR."</a>\n";
     echo "          : <a href=\"javascript:ch_group('".$id."');\" class=opt>"._GROUP2."</a></TD>";
     echo "       </TR>\n";
     $num++;
    }
  }
 echo "       <TR><TD colspan=5 align=center bgcolor=\"#c5dce0\"><b>"._TOTALLINKS.": <font color=\"#556c70\">".$num."</font></b></TD></TR>\n";
?>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
   </FORM>
  </TD>
 </TR>
</TABLE>
<table align=center border=0 class=text cellpadding=1 cellspacing=1>
 <form action="admin.php" method=post name=form>
<?php
 if(isset($error_m)) {
?>
  <tr>
   <td align="center" colspan=2>
    <font color="#ff0000"><b><?=_ERROR?>: <?=$error_m?></b></font><br><br>
   </td>
  </tr>
<?php } ?>
 <tr>
  <td align=center colspan=2 bgcolor="#a5bcc0">
   <font style="letter-spacing : 3px;"><?=_ADDLINK?>:</font>
  </td>
 </tr>
 <tr>
  <td align=right bgcolor="#e9e9e9"><?=_GROUP?>: </td>
  <td bgcolor="#e9e9e9">
    <select name="add_group" style="width: 150pt;">
     <option value=0><?=_COMMON?></option>
<?php
 $group_base=@file($groupfile); $cnt=sizeof($group_base);
 for($i=0;$i<$cnt;$i++) {
   list($id,$grname)=explode("|", $group_base[$i]);
   echo "     <option ";
   if($gr == $id) echo "selected ";
   echo "value=\"".$id."\">".$grname."</option>\n";
  }
?>
    </select>
  </td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_ID?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_id" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_NAME?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_name" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_URL?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_url" value="http://" class="field" style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" colspan=2 bgcolor="#e9e9e9">
   <input type="hidden" name="admin" value="add_link">
   <input type="submit" value="<?=_ADDOBJECT?>" class=button style="width: 150pt;" onclick="return check_form();">
  </td>
 </tr>
 </form>
</table>
<?php
 foot();
}

// Actions above recordings

function action() {
global $datafile, $admin, $fid, $new, $error_m;

if($admin <> "del" &&
   $admin <> "ch_id" &&
   $admin <> "ch_count" &&
   $admin <> "ch_url" &&
   $admin <> "ch_name" &&
   $admin <> "ch_group") break;

$f2 = fopen($datafile, "r");
flock($f2, 2);                                 // File Lock
$base=file($datafile); $cnt=sizeof($base);

$base[0] = ($base[0] + 0)."\n";
for($i=1;$i<$cnt;$i++) {
  list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
  if($id==$fid) {
    if($admin == "del") { $base[$i]=""; clear(1); }
    else if($admin == "ch_id") {
      for($j=1;$j<$cnt;$j++) {
        list($group1,$id1,$count1,$url1,$name1)=explode("|", $base[$j]);
        if($id1 == $new) {$found = 1; break;}
       }
      $new = str_replace(" ", "", $new);
      $base[$i]="$group|$new|$count|$url|$name|\n";
     }
    else if($admin == "ch_count")
     $base[$i]="$group|$id|$new|$url|$name|\n";
    else if($admin == "ch_url")
     $base[$i]="$group|$id|$count|$new|$name|\n";
    else if($admin == "ch_name")
     $base[$i]="$group|$id|$count|$url|$new|\n";
    else if($admin == "ch_group")
     $base[$i]="$new|$id|$count|$url|$name|\n";
   }
  else {
    $base[$i]=$group."|".$id."|".$count."|".$url."|".$name."|\n";
   }
 }

 if(!$found) {
   $str=implode($base,"");
   $f=fopen($datafile, "w");
   fwrite($f, $str);
   fclose($f);
  }
 else $error_m = _IDEXISTS;

 flock($f2, 3);             // File UnLock
 fclose($f2);
}

// Add ULR

function add_link() {
 global $HTTP_POST_VARS;
 global $datafile, $error_m;

 $add_group = $HTTP_POST_VARS["add_group"];
 $add_id    = $HTTP_POST_VARS["add_id"];
 $add_name  = $HTTP_POST_VARS["add_name"];
 $add_url   = $HTTP_POST_VARS["add_url"];

 $f2 = fopen($datafile, "r");
 flock($f2, 2);                                 // File Lock

 $base=file($datafile); $cnt=sizeof($base);
 $add_id = str_replace(" ", "", $add_id);

 for($i=1;$i<$cnt;$i++) {
   list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
   if($id == $add_id) { $found = 1; break; }
  }
 if(!$found)
  {
   if(!file_exists($datafile)) $add_str = time()."\n";
   $add_str.=$add_group."|".$add_id."|0|".$add_url."|".$add_name."|\n";
   $f=fopen($datafile, "a");
   fwrite($f, $add_str);
   fclose($f);
  }
 else $error_m = _IDEXISTS;

 flock($f2, 3);             // File UnLock
 fclose($f2);
}

// Clear statistic

function clear($fl = 0) {
 global $datafile, $fid, $dayfile;

 $found = 0;      // ID find flag

 if(!$fl) {
   $f2 = fopen($datafile, "r");
   flock($f2, 2);                                 // File Lock

   $base=@file($datafile); $cnt=sizeof($base);
   $base[0] = ($base[0] + 0)."\n";
   for($i=1;$i<$cnt;$i++) {
     list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
     if($id==$fid) {
       $found = 1;
       $base[$i]=$group."|".$id."|0|".$url."|".$name."|\n";
      }
     else {
       $base[$i]=$group."|".$id."|".$count."|".$url."|".$name."|\n";
      }
    }
   if($found) {
     $str=implode($base,"");
     $f=fopen($datafile, "w");
     fwrite($f, $str);
     fclose($f);
    }

   flock($f2, 3);             // File UnLock
   fclose($f2);
  }

 $f2 = fopen($dayfile, "r");
 flock($f2, 2);                                 // File Lock

 $daylog=@file($dayfile); $cnt=sizeof($daylog);
 $found = 0;
 for($i=0;$i<$cnt;$i++) {
   list($day,$group,$id,$count)=explode("|", $daylog[$i]);
   if($fid == $id) {
     $found = 1;
     $daylog[$i]="";
    }
   else {
     $daylog[$i]=$day."|".$group."|".$id."|".$count."|\n";
    }
  }
 if($found) {
   $str=implode($daylog,"");
   $f=fopen($dayfile, "w");
   fwrite($f, $str);
   fclose($f);
  }

 flock($f2, 3);             // File UnLock
 fclose($f2);
}

// Configure Groups

function gr_config() {
 global $datafile, $error_m, $gr, $groupfile;
 $gr+=0;
 head();
?>
<script language="Javascript">
<!--
function check_char(strg) {
 var found = 0;
 for(char_pos=0; char_pos<strg.length; char_pos++) {
   if(strg.charAt(char_pos) == "|" || strg.charAt(char_pos) == "&" || strg.charAt(char_pos) == "=" || strg.charAt(char_pos) == '"' || strg.charAt(char_pos) == "'") {
     found = 1;
     break;
    }
  }
 return (found == 1) ? false : true;
}
function ChangeEntry(entry, old_name, feature) {
 var new_name = window.prompt("<?=_ENTER?> "+feature+" <?=_FOR?> "+entry+":",old_name)
 var found = 1;
 if(new_name != "" && new_name != null) {
   if(check_char(new_name)) {
     found = 0;
    }
   if (found == 1) {
     alert ("<?=_ERROR?>! "+feature+" <?=_FOR?> "+entry+" <?=_UNACCEPTCHARS?>!");
    }
   else if(new_name == old_name) {
     alert ("<?=_CHNOTMADE?>!");
    }
   else if(feature == "Name") {
     window.location.href = "admin.php?admin=chgr_name&gr="+entry+"&new="+new_name
    }
   else if(feature == "ID") {
     window.location.href = "admin.php?admin=chgr_id&gr="+entry+"&new="+new_name
    }
  }
}
function del_entry(entry) {
 if (window.confirm("<?=_CONFIRMDEL?>: "+entry)) {
    window.location.href = "admin.php?admin=del_gr&gr="+entry
 }
}
function clear_entry(entry) {
 if (window.confirm("<?=_CONFIRMDELSTAT?>: "+entry)) {
    window.location.href = "admin.php?admin=clear_gr&gr="+entry
 }
}
function check_form() {
 var found = 1;
 name_field=document.form.add_name.value;
 id_field=document.form.add_id.value;
 if (name_field == "" || id_field == "") {
    alert ("<?=_PLEASEFILL?>");
    return false;
 }
 if (check_char(name_field) && check_char(id_field)) {
    found = 0;
 }
 if (found == 1) {
    alert ("<?=_ERROR?>! <?=_FOUNDUNACCEPTCHARS?>!");
    return false;
 }
}
// -->
</script>
<DIV align=center style="font-size:14pt; letter-spacing:2pt;"><B><?=_CONTROLPANEL?></B></DIV>
<TABLE cellpadding=4 cellspacing=4 border=0 width="100%">
 <TR>
  <TD valign=top>
   <TABLE border=0 class=text width="100%" cellpadding=2 cellspacing=1>
    <TR><TD bgcolor="#a5bcc0" align=center style="font-size:9pt;"><B>.: <?=_MENU?> :.</B></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>"><B>.: <?=_STATISTIC?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=config"><B>.: <?=_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?gr=<?=$gr?>&admin=gr_config"><B>.: <?=_GR_CONFIG?></B></A></TD></TR>
    <TR><TD align=center><A href="admin.php?admin=logout"><B>.: <?=_LOGOUT?></B></A></TD></TR>
   </TABLE>
  </TD>
  <TD width="85%">
   <TABLE bgcolor="#000000" cellpadding=0 cellspacing=1 border=0 width="100%">
    <TR>
     <TD>
      <TABLE bgcolor="#FFFFFF" cellpadding=2 cellspacing=1 border=0 width="100%" class=text>
       <TR><TD bgcolor="#a5bcc0" align=center colspan=5><?=_GRLIST?></TD></TR>
       <TR>
        <TD bgcolor="#c5dce0" align=center><B><?=_ID?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_NAME?></B></TD>
        <TD bgcolor="#c5dce0" align=center><B><?=_ACTIONS?></B></TD>
       </TR>
<?php
 $groups=@file($groupfile); $cnt=sizeof($groups);
 $num=0;
 for($i=0;$i<$cnt;$i++) {
   list($id,$name)=explode("|", $groups[$i]);
    echo "       <TR>\n";
    echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('$id', '$id', 'ID')\" class=opt>$id</a></TD>\n";
    echo "        <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('$id', '$name', 'Name')\" class=opt>$name</a></TD>\n";
    echo "        <TD bgcolor=\"#e9e9e9\" align=center width=140><a href=\"javascript:del_entry('$id');\" class=opt>"._DELETE."</a>\n";
    echo "          : <a href=\"javascript:clear_entry('$id');\" class=opt>"._CLEAR."</a></TD>\n";
    echo "       </TR>\n";
    $num++;
  }
 echo "       <TR><TD colspan=5 align=center bgcolor=\"#c5dce0\"><b>"._TOTALGROUP.": <font color=\"#556c70\">$num</font></b></TD></TR>\n";
?>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<table align="center" border=0 class=text cellpadding=1 cellspacing=1>
 <form action="admin.php" method=post name=form>
<?php
 if(isset($error_m)) {
?>
  <tr>
   <td align=center colspan=2>
    <font color="#ff0000"><b><?=_ERROR?>: <?=$error_m?></b></font><br><br>
   </td>
  </tr>
<?php } ?>
 <tr>
  <td align="center" colspan=2 bgcolor="#a5bcc0">
   <font style="letter-spacing : 3px;"><?=_ADDGROUP?>:</font>
  </td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_ID?>: </td>
  <td bgcolor="#e9e9e9"><input type=text name="add_id" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_NAME?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_name" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" colspan=2 bgcolor="#e9e9e9">
   <input type="hidden" name="admin" value="add_group">
   <input type="submit" value="<?=_ADDOBJECT?>" class=button style="width: 150pt;" onclick="return check_form();">
  </td>
 </tr>
 </form>
</table>
<?php
 foot();
}

// Actions above groups

function gr_action() {
 global $groupfile, $admin, $gr, $new, $error_m;

 $f2 = fopen($groupfile, "r");
 flock($f2, 2);                                 // File Lock
 $gr_base=file($groupfile); $cnt=sizeof($gr_base);
 for($i=0;$i<$cnt;$i++) {
   list($id,$name)=explode("|", $gr_base[$i]);
   if($id==$gr) {
     if($admin == "del_gr") { $gr_base[$i]=""; clear_gr(); }
     else if($admin == "chgr_id") {
       for($j=0;$j<$cnt;$j++) {
         list($id1,$name1)=explode("|", $gr_base[$j]);
         if($id1 == $new) {$found = 1; break;}
        }
       $new = str_replace(" ", "", $new);
       $gr_base[$i]=$new."|".$name."|\n";
      }
     else if($admin == "chgr_name") $gr_base[$i]=$id."|".$new."|\n";
    }
   else {
     $gr_base[$i]=$id."|".$name."|\n";
    }
  }

 if(!$found) {
   $str=implode($gr_base,"");
   $f=fopen($groupfile, "w");
   fwrite($f, $str);
   fclose($f);
  }
 else $error_m = _IDEXISTS;

 flock($f2, 3);             // File UnLock
 fclose($f2);
}

// Add Group

function add_group() {
 global $HTTP_POST_VARS;
 global $error_m, $groupfile;

 $add_id    = $HTTP_POST_VARS["add_id"];
 $add_name  = $HTTP_POST_VARS["add_name"];

 $f2 = fopen($groupfile, "r");
 flock($f2, 2);                                 // File Lock
 $gr_base=@file($groupfile); $cnt=sizeof($gr_base);
 $add_id = str_replace(" ", "", $add_id);

 for($i=0;$i<$cnt;$i++) {
   list($id,$name)=explode("|", $gr_base[$i]);
   if($id == $add_id) { $found = 1; break; }
  }
 if(!$found)
  {
   $add_str=$add_id."|".$add_name."|\n";
   $f=fopen($groupfile, "a");
   fwrite($f, $add_str);
   fclose($f);
  }
 else $error_m = _IDEXISTS;

 flock($f2, 3);             // File UnLock
 fclose($f2);
}

// Clear group

function clear_gr() {
global $datafile, $gr, $dayfile, $groupfile, $fid;

$base=@file($datafile); $cnt=sizeof($base);
$found = 0;
for($i=1;$i<$cnt;$i++) {
  list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
  if($group==$gr) { $fid=$id; clear(); }
 }
}

// Referrers show

function show_referrers() {
 global $HTTP_GET_VARS;
 global $datafile, $reffile, $fid;
 head();

 $period = $HTTP_GET_VARS["period"];

 if(!isset($period)) $period=1;

 $today=(int)(time()/86400);

 $num = 0; $c_all=0;

 $base=@file($datafile); $cnt=sizeof($base);
 for($i=1;$i<$cnt;$i++) {
   list($group,$id,$count,$url,$name)=explode("|", $base[$i]);
   if($fid==$id) {
       $link_name = $name;
       break;
    }
  }

 $ref_base=@file($reffile); $cnt=sizeof($ref_base);
 for($i=0;$i<$cnt;$i++) {
   list($day,$group,$id,$refurl,$count)=explode("|", $ref_base[$i]);
   if($fid==$id) {
     if($refurl=="") $refurl="unknow";
     if(($day==$today) && ($period==1)) { $ref_b[$refurl]+=$count; $c_all+=$count;}
     else if(($day==$today-1) && ($period==-1)) { $ref_b[$refurl]+=$count; $c_all+=$count;}
     else if(($day<$today+7) && ($period==7)) { $ref_b[$refurl]+=$count; $c_all+=$count;}
    }
  }
 $num=sizeof($ref_b);
 @arsort($ref_b);   // Sorting

 echo "<DIV align=center style=\"font-size:14pt; letter-spacing:2pt;\"><B>"._REFERRINGPAGES." \n";
 if($period == 1) echo _FOR." "._TODAY;
 else if($period == -1) echo _FOR." "._YESTERDAY;
 else if($period == 7) echo _FORWEEK2;
 echo "</B></DIV><br>\n";
 echo "<DIV align=center><B>"._PERIOD.":</B> <a href=\"admin.php?admin=show_ref&fid=".$fid."&period=1\">"._TODAY."</a>\n";
 echo "  | <a href=\"admin.php?admin=show_ref&fid=".$fid."&period=-1\">"._YESTERDAY."</a>\n";
 echo "  | <a href=\"admin.php?admin=show_ref&fid=".$fid."&period=7\">"._FORWEEK."</a></DIV>\n";
?>
<TABLE cellpadding=4 cellspacing=4 border=0 width="100%" align=center>
 <TR>
  <TD>
   <TABLE bgcolor="#000000" cellpadding=0 cellspacing=1 border=0 width="100%">
    <TR>
     <TD>
       <TABLE bgcolor="#FFFFFF" cellpadding=2 cellspacing=1 border=0 width="100%" class=text>
<?
 echo "        <TR><TD bgcolor=\"#a5bcc0\" align=center colspan=6><b>"._LINK.":</b> ".$link_name."</TD></TR>\n";
?>        <TR>
         <TD bgcolor="#c5dce0" align=center><B><?=_NUMBER?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_PAGE?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_AMOUNT?></B></TD>
         <TD bgcolor="#c5dce0" align=center><B><?=_PERCENT?></B></TD>
        </TR>
<?php
 @reset($ref_b);
 for($i=0;$i<$num;$i++) {
   $key = key($ref_b);
   echo "        <TR>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".($i+1)."</TD>\n";
   if($key!="unknow")
     echo "         <TD bgcolor=\"#e9e9e9\" align=center><a href=\"".$key."\" target=\"_blank\">".$key."</a></TD>\n";
   else
     echo "         <TD bgcolor=\"#e9e9e9\" align=center>"._UNKNOWN."</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".$ref_b[$key]."</TD>\n";
   echo "         <TD bgcolor=\"#e9e9e9\" align=center>".(round($ref_b[$key]/$c_all*10000)/100)."</TD>\n";
   echo "        </TR>\n";
   next($ref_b);
  }
 echo "        <TR>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>"._TOTAL."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$today_all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>".$c_all."</b></TD>\n";
 echo "         <TD bgcolor=\"#c5dce0\" align=center><b>100.00</b></TD>\n";
 echo "        </TR>\n";
 echo "        <TR><TD colspan=5 align=center><b>"._TOTALPAGES.": <font color=\"#556c70\">".$num."</font></b></TD></TR>\n";
?>
       </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<?php
 foot();
}

// Main

session_start();

//if(!isset($HTTP_SESSION_VARS["log"])) {
//  $HTTP_SESSION_VARS["log"] = 0;
//  session_register('log');
// }

if(!isset($_SESSION['log'])) {
  $_SESSION['log'] = 0;
 }

if(isset($HTTP_POST_VARS["admin"])) $admin = $HTTP_POST_VARS["admin"];
else if(isset($HTTP_GET_VARS["admin"])) $admin = $HTTP_GET_VARS["admin"];

if(isset($HTTP_POST_VARS["add_group"])) $gr = $HTTP_POST_VARS["add_group"];
else if(isset($HTTP_GET_VARS["gr"])) $gr = $HTTP_GET_VARS["gr"];

if(isset($HTTP_GET_VARS["fid"])) $fid = $HTTP_GET_VARS["fid"];
if(isset($HTTP_GET_VARS["new"])) $new = $HTTP_GET_VARS["new"];

if(!$_SESSION['log']) { login(); }
//if(!$HTTP_SESSION_VARS["log"]) { login(); }
else if($admin == "gr_config") { gr_config(); }
else if($admin == "chgr_name" || $admin=="chgr_id" || $admin=="del_gr") { gr_action(); gr_config(); }
else if($admin == "clear_gr") { clear_gr(); gr_config(); }
else if($admin == "add_group") { add_group(); gr_config(); }
else if($admin == "config") { config(); }
else if($admin == "clear") { clear(); config(); }
else if($admin == "add_link") { add_link(); config(); }
else if($admin == "logout") { session_unset(); session_destroy(); login(); }
else if($admin == "show_ref") { show_referrers(); }
else if(isset($admin)) { action(); config(); }
else { show(); }
?>
